Aria table "is marked as crashed and should be repaired"

Bug #670356 reported by Philip Stoev on 2010-11-03
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
MariaDB
Fix Released
High
Michael Widenius

Bug Description

When executing recovery from the SMF scenario, the server reports the following:

# 2010-11-03T00:15:01 101103 0:15:01 [ERROR] mysqld: Table './smf2/smf_calendar_holidays' is marked as crashed and should be repaired
# 2010-11-03T00:15:01 101103 0:15:01 [Warning] Checking table: './smf2/smf_calendar_holidays'

The tables are positively Aria tables, created with --default-storage-engine=Aria. maria_read_log does not report any issues. There are no other error messages about corruption or zerofilling.

RQG command line:

/home/buildbot/randgen/runall.pl \
--queries=1M \
--engine=Maria \
--mysqld=--default-storage-engine=Maria \
--mysqld=--safe-mode \
--mysqld=--sync-sys=0 \
--mysqld=--log-output=file \
--mysqld=--maria_log_purge_type=at_flush \
--reporters=ErrorLog,Backtrace,Recovery,Shutdown \
--duration=240 \
--threads=20 \
--rows=10 \
--mask-level=1 \
--queries=100000000 \
--mask=50154 \
--seed=1288735776 \
--mysqld=--maria-repair-threads=2 \
--mysqld=--loose-maria-group-commit=hard \
--mysqld=--loose-maria_group_commit_interval=10 \
--mysqld=--maria-checkpoint-interval=0 \
--mysqld=--maria-block-size=4K \
--mysqld=--init-file=/home/buildbot/randgen/conf/smf/smf2.sql \
--grammar=conf/smf/smf2.yy \
--basedir=.

bzr version-info:

revision-id: <email address hidden>
date: 2010-11-02 21:01:25 +0200
build-date: 2010-11-02 22:29:06 +0200
revno: 2965
branch-nick: 5.1
------------------------------------------------------------
revno: 2965
committer: <email address hidden>
branch nick: work-maria-5.1-define
timestamp: Tue 2010-11-02 21:01:25 +0200
message:
  #endif fixed.

Related branches

Philip Stoev (pstoev-askmonty) wrote :

NOT reproducible with the testing cycle from Nov3th-Nov4th

revision-id: <email address hidden>
date: 2010-11-03 14:18:18 +0200
build-date: 2010-11-03 15:00:40 +0200
revno: 2966
branch-nick: 5.1
------------------------------------------------------------
revno: 2966 [merge]
committer: Michael Widenius <email address hidden>
branch nick: maria-5.1
timestamp: Wed 2010-11-03 14:18:18 +0200
message:
  Automatic merge
------------------------------------------------------------

Philip Stoev (pstoev-askmonty) wrote :

REPRODUCIBLE with the testing cycle from Nov5th. Will try to obtain the tablespace.

Philip Stoev (pstoev-askmonty) wrote :

Also reproducible with:

revision-id: <email address hidden>
date: 2010-11-16 12:32:36 +0200
build-date: 2010-11-16 12:46:56 +0200
revno: 2972
branch-nick: 5.1
------------------------------------------------------------
revno: 2972
committer: <email address hidden>
branch nick: work-maria-5.1-itemtype-bugs
timestamp: Tue 2010-11-16 12:32:36 +0200
message:
  Fixed mess in the types.

Changed in maria:
milestone: none → 5.1
Philip Stoev (philip-stoev) wrote :

Still reproducible with the tree from Jan 06

Changed in maria:
assignee: nobody → Michael Widenius (monty)
Philip Stoev (philip-stoev) wrote :

vardir before recovery, log, etc.

In this particular dataset, smf_log_group_requests is the crashed table

Philip Stoev (philip-stoev) wrote :

Still repeatable with

revision-id: <email address hidden>
date: 2011-01-24 15:19:40 +0200
build-date: 2011-01-25 15:42:06 +0200
revno: 3020
branch-nick: 5.1
------------------------------------------------------------
revno: 3020
committer: Michael Widenius <email address hidden>
branch nick: maria-5.1
timestamp: Mon 2011-01-24 15:19:40 +0200
message:
  Aria issues:
  - Fix for LP#700623 "Aria recovery: ma_blockrec.c:3930: _ma_update_at_original_place: Assertion `block->org_bitmap_value == _ma_bitmap_get_page_bits(info, &info->s->bitmap, page)' failed"
    - Issue was that when deleting a tail page where all index entries where full, the page was marked wrongly in the bitmap.
  - If debug_assert_if_crashed_table is set, we now crash when we find Aria corrupted.
  - Write more information if we find something wrong with the bitmap.
  - Fixed that REPAIR also can fix wrong create_rename_lsn issues (a very unlikely event)
  - Define STATE_CRASHED_FLAGS as set of all CRASHED flags (to simplify code)

Changed in maria:
status: New → Confirmed
Philip Stoev (philip-stoev) wrote :

Still repeatable as before with

revision-id: <email address hidden>
date: 2011-01-30 16:44:57 +0200
build-date: 2011-02-01 22:49:52 +0200
revno: 3027
branch-nick: 5.1
------------------------------------------------------------
revno: 3027
committer: Michael Widenius <email address hidden>
branch nick: maria-5.1
timestamp: Sun 2011-01-30 16:44:57 +0200
message:
  Ignore some linked files

Michael Widenius (monty) on 2011-02-02
Changed in maria:
importance: Undecided → High
Michael Widenius (monty) on 2011-02-02
Changed in maria:
status: Confirmed → In Progress
Michael Widenius (monty) wrote :

Have run test case for some hours with latest 5.1 tree without problems.
I observed and fixed a similar error when working on the test case for the previous recovery bug, so I assume this is now also fixed.

Changed in maria:
status: In Progress → Fix Committed
Philip Stoev (philip-stoev) wrote :

Unforuntately this is still repeatable with the following revision:

revision-id: <email address hidden>
date: 2011-02-03 16:03:54 +0200
build-date: 2011-02-03 19:43:39 +0200
revno: 3031
branch-nick: 5.1
------------------------------------------------------------
revno: 3031
committer: Michael Widenius <email address hidden>
branch nick: maria-5.1
timestamp: Thu 2011-02-03 16:03:54 +0200
message:
  Added missing header file strings_def.h to dist

RQG command lines:

/home/buildbot/randgen/runall.pl \
--queries=1M \
--engine=Maria \
--mysqld=--default-storage-engine=Maria \
--mysqld=--safe-mode \
--mysqld=--loose-debug-assert-if-crashed-table \
--mysqld=--sync-sys=0 \
--mysqld=--log-output=file \
--mysqld=--maria_log_purge_type=at_flush \
--reporters=ErrorLog,Backtrace,Recovery,Shutdown \
--duration=30 \
--threads=10 \
--rows=100 \
--mask-level=0 \
--mysqld=--loose-maria-group-commit=hard \
--mysqld=--loose-maria_group_commit_interval=0 \
--mysqld=--maria-checkpoint-interval=1 \
--mysqld=--maria-block-size=16K \
--queries=100000000 \
--mask=5570 \
--seed=1296764661 \
--basedir=. \
--mysqld=--init-file=/home/buildbot/randgen/conf/smf/smf2.sql \
--grammar=conf/smf/smf2.yy

and

runall.pl \
--queries=1M \
--engine=Maria \
--mysqld=--default-storage-engine=Maria \
--mysqld=--safe-mode \
--mysqld=--loose-debug-assert-if-crashed-table \
--mysqld=--sync-sys=0 \
--mysqld=--log-output=file \
--mysqld=--maria_log_purge_type=at_flush \
--reporters=ErrorLog,Backtrace,Recovery,Shutdown \
--duration=120 \
--threads=20 \
--rows=10000 \
--mask-level=0 \
--mysqld=--loose-maria-group-commit=hard \
--mysqld=--loose-maria_group_commit_interval=0 \
--mysqld=--maria-checkpoint-interval=1 \
--mysqld=--maria-block-size=4K \
--queries=100000000 \
--mask=42425 \
--seed=1296796973 \
--basedir=. \
--mysqld=--init-file=/home/buildbot/randgen/conf/smf/smf2.sql \
--grammar=conf/smf/smf2.yy

Changed in maria:
status: Fix Committed → Confirmed
Michael Widenius (monty) wrote :

I have recently fixed several similar cases in Aria in 5.2
I did run the last test for some time s to verify this and as I got no errors I will close this bug report.

Changed in maria:
status: Confirmed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers